SystemOrganization addCategory: #ParcialMartinezCruz!

Object subclass: #ParcialMartinezCruz
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialMartinezCruz'!

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/5/2012 03:57'!
Pregunta1
"La resposta a aquesta pregunta es por veure a la classe Matriu.
Per tal de fer una interficie mes completa he fet que la matriu pugui ser quadrada i de dimensions Files*Columnes. Tamb he afegir alguns missatges addicionals.
Les linies que hi han a continuacio, descomentades poden servir per fer proves a la classe:
-----------------------------------------------------------------------------------------------------------------------------------------------"

"| mat |"

"--Matriu quadrada inicialitzada amb 0"
"mat := Matriu new: 3."
"Transcript show: mat."

"--Omplim les caslles amb nombres aleatoris (entre 1 i 9)"
"mat ompleAmbAleatori:  9."
"Transcript show: mat."

"--Matriu no quadrada amb totes les caselles omplertes amb 8"
"mat := Matriu new: 3 per: 2."
"mat ompleAmb: 8."
"Transcript show: mat."

"--Consultem la posicio 1x1"
"Transcript show: 'Contingut (1x1) = ', (mat at: (1@1)) asString; cr."

"--Modifiquem posicio 1x1 amb el valor 1 i mostrem la matriu"
"mat at: (1@1) put: 1."
"mat pintaMatriu."! !

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/4/2012 19:09'!
Pregunta2
"Resputesta a la pregunta 2"
! !

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/4/2012 19:09'!
Pregunta3
"Respuesta a la pregunta 3"! !

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/4/2012 19:10'!
Pregunta4
"Respuesta a la pregunta 4"! !

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/4/2012 19:11'!
Pregunta5
"Implementacio de HALTIF"! !

!ParcialMartinezCruz methodsFor: 'preguntes' stamp: 'DanielMartinez 11/4/2012 19:12'!
Pregunta6
"Aquesta resposta la trobem al fitxer .java adjunt"! !

OrderedCollection subclass: #Matriu
	instanceVariableNames: 'files columnes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ParcialMartinezCruz'!

!Matriu class methodsFor: 'instance creation' stamp: 'DanielMartinez 11/5/2012 03:28'!
new: unNombre
	"Crea i retorna una matriu quadrada de unNombre*unNombre (quadrada)"
	
	^self new: unNombre per: unNombre.! !

!Matriu class methodsFor: 'instance creation' stamp: 'DanielMartinez 11/5/2012 00:43'!
new: files per: columnes
	"Crea i retorna una matriu de files*columnes"

	| mat |
	mat := super new: files.
	mat inicialitzar: files per: columnes.
	^mat.! !

!Matriu methodsFor: 'accessing' stamp: 'DanielMartinez 11/5/2012 03:30'!
at: unParell
	"Retorna el valor emmagatzemat a la matriu, posicio ( unParell x, unParell y)"

	^( ( super at: unParell x ) at: unParell y ).! !

!Matriu methodsFor: 'assignacio' stamp: 'DanielMartinez 11/5/2012 03:30'!
at: unParell put: unNumero
	"asigna unValor a la posicio ( unParell x, unParell y) i retorna aquest valor, per comprovar-ho."

	^( ( super at: unParell x ) at: unParell y put: unNumero ).! !

!Matriu methodsFor: 'consulta' stamp: 'DanielMartinez 11/4/2012 20:04'!
columnes
	"retorna el numero de columnes de la matriu"
	^columnes.! !

!Matriu methodsFor: 'consulta' stamp: 'DanielMartinez 11/4/2012 20:07'!
esQuadrada
	"Retorna true si el numero de files i columnes de la matri es igual"

	^( files = columnes ).! !

!Matriu methodsFor: 'consulta' stamp: 'DanielMartinez 11/4/2012 20:12'!
files
	"retorna el numero de files de la matriu"
	^files.! !

!Matriu methodsFor: 'inicialitzar' stamp: 'DanielMartinez 11/5/2012 00:43'!
inicialitzar: numeroFiles per: numeroColumnes
	"Inicialitza les files i columnes de la matriu i el seu contingut amb zeros"

	files := numeroFiles.
	columnes := numeroColumnes.
	
	1 to: files do: [ :filaActual | self add: ( Array new: columnes ).
						1 to: columnes do: [ :columnaActual | ( super at: filaActual ) at: columnaActual put: 0 ].
					].! !

!Matriu methodsFor: 'assignacio' stamp: 'DanielMartinez 11/5/2012 03:15'!
ompleAmb: unNumero
	"Omple totes les caselles de la matriu amb unNumero"
	
	1 to: files do: [ :filaActual |
						self add: ( Array new: columnes ).
						1 to: columnes do: [ :columnaActual |
							( super at: filaActual ) at: columnaActual put: unNumero ].
					].! !

!Matriu methodsFor: 'assignacio' stamp: 'DanielMartinez 11/5/2012 03:16'!
ompleAmbAleatori: maxim 
	"Omple les caselles de la matriu amb un nombre aleatori entre 1 i maxim"
	
	1 to: files do: [ :filaActual |
						self add: ( Array new: columnes ).
						1 to: columnes do: [ :columnaActual |
							( super at: filaActual ) at: columnaActual put: maxim atRandom ].
					].! !

!Matriu methodsFor: 'printing' stamp: 'DanielMartinez 11/5/2012 03:48'!
pintaMatriu
	"mostra pel transcipt el contingut de la matriu formatejat."
	Transcript show: 'Dimensions: (', self files asString ,'x', self columnes asString ,')';cr.
	1 to: files do: [ :filaActual |
						1 to: columnes do: [ :columnaActual | Transcript show: '[ ' , (self at: filaActual@columnaActual)  asString , ' ]'. ].
						Transcript show: ''; cr.
				]. ! !

!Matriu methodsFor: 'printing' stamp: 'DanielMartinez 11/5/2012 03:39'!
printOn: aStream 
	"Pinta les caracteristicas de la matriu."
	aStream nextPutAll: '---------------------------------------------'; cr.
	aStream nextPutAll: 'Caracteristiques de la matriu:'; cr.
	aStream nextPutAll: '---------------------------------------------'; cr.
	
	aStream nextPutAll: 'Dimensions: (', self files asString ,'x', self columnes asString ,') --> '.
	self esQuadrada = true
				ifTrue: [ aStream nextPutAll: 'Quadrada'; cr] 
				ifFalse: [ aStream nextPutAll: 'No quadrada'; cr].
	
	1 to: files do: [ :filaActual |
						1 to: columnes do: [ :columnaActual | aStream nextPutAll: '[ ' , (self at: filaActual@columnaActual)  asString , ' ]'. ].
						aStream nextPutAll: ''; cr.
					].! !
